/* xmms-winamp
   plugin helper binary, functions to list available plugins/modules
   
   (C) 2002 Ulrich Hecht
   Licensed under the terms of the GNU General Public License v2
 */

#include <windows.h>
#include "vis.h"
#include <dirent.h>
#include <stdio.h>

void list_plugins(void)
{
	char* dirname;
	DIR* dir;
	struct dirent* entry;
	HINSTANCE dll;
	winampVisGetHeaderType headerfunc=0;
	winampVisHeader* header;
	char filename[255];
	
	dirname=getenv("DLLNAME");
	dir=opendir(dirname);
	while((entry=readdir(dir)))
	{
		//printf("entry %s\n",entry->d_name);
		strcpy(filename,dirname);
		strcat(filename,"/");
		strcat(filename,entry->d_name);
		dll=LoadLibrary(filename);
		if(!dll) continue;
		headerfunc=(winampVisGetHeaderType)GetProcAddress(dll,"winampVisGetHeader");
		if(!headerfunc)
		{
			FreeLibrary(dll);
			continue;
		}
		header=headerfunc();
		printf("\nWALIST%s,,%s\n",entry->d_name,header->description);
		FreeLibrary(dll);
	}
	closedir(dir);
}

void list_modules(void)
{
	int i=0;
	HINSTANCE dll;
        winampVisGetHeaderType headerfunc=0;
        winampVisHeader* header;
        winampVisModule* module;
	                
	dll=LoadLibrary(getenv("DLLNAME"));
	headerfunc=(winampVisGetHeaderType)GetProcAddress(dll,"winampVisGetHeader");
	header=headerfunc();
	while((module=header->getModule(i)))
	{
		printf("\nWALIST%s\n",module->description);
		i++;
	}
	FreeLibrary(dll);
}
